package ladasha.statistics;

import java.util.*;
import ladasha.io.*;

public class GaussianRNG {

  private static boolean previous;
  private static boolean previous2;
  private static double c;
  private static double t1;
  private static double t2;
  private static double g;
  private static double c1;
  private static Random r;
  private static GaussianRNG instance;
  private static Logger logger = Logger.getInstance();
    
  public static GaussianRNG getInstance() {
    logger.log("obtaining instance of GaussianRNG");
    if (instance == null) instance = new GaussianRNG();
    return instance;
  }

  private GaussianRNG() {
    previous = false;
    previous2 = false;
    r = new Random();
  }
  
  public static double next() {
    if (previous) {
      previous = false;
      logger.log("GaussianRNG: next(): returning " + c);
      return c;		
    } else {
      double s;
      do { 
        t1 = r.nextDouble() * 2 - 1;
        t2 = r.nextDouble() * 2 - 1;
        s = (t1 * t1) + (t2 * t2);
      } while (s >= 1 || s == 0);
      g = Math.sqrt(-2 * Math.log(s)/s);
      c = t1 * g;
      c1 = t2 * g;
      previous = true;
      previous2 = true;
      logger.log("GaussianRNG: next(): returning " + c1);
      return c1;
    }
  }

  public static double next(double mean, double variance) {
    double retval = next() * variance + mean;
    logger.log("GaussianRNG: next(mean,variance): returning " + retval);
    return retval;
  }
}
/*
  public double nextCorrecting(double mean, double variance) {
    if (previous2) {
      previous = false;
      double variance2 = (c1 - mean == 0) ? 1 : (c1);
      return next(((c1 + mean)/2), variance/variance2);
    } else return next();
  }
}


class GaussianTester {

	static GaussianRNG g;
	static Scanner sc = new Scanner(System.in);
	static Random r = new Random();
        static double mean;
	static double variance;	

	public static void seuss() {
		System.out.println("My code:");
		g.getInstance();
		for (int i = 0; i < 20; i++) { 
			int j = (int)(10 * g.next());
			System.out.println(j);
		}
	}

	public static void gauss() {
		System.out.println("Java Random:");
		g.getInstance();
		for (int i = 0; i < 20; i++) {
			int j = (int)(10 * r.nextGaussian());
			System.out.println(j);
		}
	}

	public static void greenEggsAndHam() {
		g.getInstance();
		System.out.print("Enter mean >");
		mean = sc.nextInt();
		System.out.print("Enter variance >");
		variance = sc.nextInt();
		System.out.println("Gaussian...");
		for (int i = 0; i < 20; i++) {
			int j = (int)(g.next(mean,variance));
			System.out.println(j);
		}
		System.out.print("Enter mean >");
		mean = sc.nextInt();
		System.out.print("Enter variance >");
		variance = sc.nextInt();
		System.out.println("Correcting...");
		for (int i = 0; i < 20; i++) {
			int j = (int)(g.nextCorrecting(mean,variance));
			System.out.println(j);
		}
	}

	public static void main(String[] args) {
		seuss();
		gauss();
		while (true) {
			greenEggsAndHam();
			System.out.print("Do you wish to exit? y or n? >");
			if (sc.next().equalsIgnoreCase("y"))
				break;
		}
	}
}
*/
